# coding: utf-8

"""
Defect Dojo API v2

Defect Dojo - Open Source vulnerability Management made easy. Prefetch related parameters/responses not yet in the schema.

The version of the OpenAPI document: 2.44.1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import date, datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing_extensions import Annotated, Self


class ExecutiveSummary(BaseModel):
    """
    ExecutiveSummary
    """  # noqa: E501

    engagement_name: Annotated[str, Field(strict=True, max_length=200)]
    engagement_target_start: date
    engagement_target_end: date
    test_type_name: Annotated[str, Field(strict=True, max_length=200)]
    test_target_start: datetime
    test_target_end: datetime
    test_environment_name: Annotated[str, Field(strict=True, max_length=200)]
    test_strategy_ref: Annotated[str, Field(strict=True, max_length=200)]
    total_findings: StrictInt
    __properties: ClassVar[List[str]] = [
        'engagement_name',
        'engagement_target_start',
        'engagement_target_end',
        'test_type_name',
        'test_target_start',
        'test_target_end',
        'test_environment_name',
        'test_strategy_ref',
        'total_findings',
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExecutiveSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExecutiveSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                'engagement_name': obj.get('engagement_name'),
                'engagement_target_start': obj.get('engagement_target_start'),
                'engagement_target_end': obj.get('engagement_target_end'),
                'test_type_name': obj.get('test_type_name'),
                'test_target_start': obj.get('test_target_start'),
                'test_target_end': obj.get('test_target_end'),
                'test_environment_name': obj.get('test_environment_name'),
                'test_strategy_ref': obj.get('test_strategy_ref'),
                'total_findings': obj.get('total_findings'),
            }
        )
        return _obj
