# coding: utf-8

"""
Defect Dojo API v2

Defect Dojo - Open Source vulnerability Management made easy. Prefetch related parameters/responses not yet in the schema.

The version of the OpenAPI document: 2.44.1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict
from typing_extensions import Self

from defectdojo_api_generated.models.finding_engagement import FindingEngagement
from defectdojo_api_generated.models.jira_instance import JIRAInstance
from defectdojo_api_generated.models.product import Product


class JIRAProjectPrefetch(BaseModel):
    """
    JIRAProjectPrefetch
    """  # noqa: E501

    engagement: Optional[Dict[str, FindingEngagement]] = None
    jira_instance: Optional[Dict[str, JIRAInstance]] = None
    product: Optional[Dict[str, Product]] = None
    __properties: ClassVar[List[str]] = ['engagement', 'jira_instance', 'product']

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JIRAProjectPrefetch from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set(
            [
                'engagement',
                'jira_instance',
                'product',
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in engagement (dict)
        _field_dict = {}
        if self.engagement:
            for _key_engagement in self.engagement:
                if self.engagement[_key_engagement]:
                    _field_dict[_key_engagement] = self.engagement[_key_engagement].to_dict()
            _dict['engagement'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each value in jira_instance (dict)
        _field_dict = {}
        if self.jira_instance:
            for _key_jira_instance in self.jira_instance:
                if self.jira_instance[_key_jira_instance]:
                    _field_dict[_key_jira_instance] = self.jira_instance[_key_jira_instance].to_dict()
            _dict['jira_instance'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each value in product (dict)
        _field_dict = {}
        if self.product:
            for _key_product in self.product:
                if self.product[_key_product]:
                    _field_dict[_key_product] = self.product[_key_product].to_dict()
            _dict['product'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JIRAProjectPrefetch from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                'engagement': dict((_k, FindingEngagement.from_dict(_v)) for _k, _v in obj['engagement'].items())
                if obj.get('engagement') is not None
                else None,
                'jira_instance': dict((_k, JIRAInstance.from_dict(_v)) for _k, _v in obj['jira_instance'].items())
                if obj.get('jira_instance') is not None
                else None,
                'product': dict((_k, Product.from_dict(_v)) for _k, _v in obj['product'].items())
                if obj.get('product') is not None
                else None,
            }
        )
        return _obj
