# coding: utf-8

"""
Defect Dojo API v2

Defect Dojo - Open Source vulnerability Management made easy. Prefetch related parameters/responses not yet in the schema.

The version of the OpenAPI document: 2.44.1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing_extensions import Self

from defectdojo_api_generated.models.note_type import NoteType
from defectdojo_api_generated.models.user_stub import UserStub


class NoteHistory(BaseModel):
    """
    NoteHistory
    """  # noqa: E501

    id: StrictInt
    current_editor: UserStub
    note_type: NoteType
    data: StrictStr
    time: Optional[datetime]
    __properties: ClassVar[List[str]] = ['id', 'current_editor', 'note_type', 'data', 'time']

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NoteHistory from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set(
            [
                'id',
                'current_editor',
                'note_type',
                'time',
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of current_editor
        if self.current_editor:
            _dict['current_editor'] = self.current_editor.to_dict()
        # override the default output from pydantic by calling `to_dict()` of note_type
        if self.note_type:
            _dict['note_type'] = self.note_type.to_dict()
        # set to None if time (nullable) is None
        # and model_fields_set contains the field
        if self.time is None and 'time' in self.model_fields_set:
            _dict['time'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NoteHistory from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                'id': obj.get('id'),
                'current_editor': UserStub.from_dict(obj['current_editor'])
                if obj.get('current_editor') is not None
                else None,
                'note_type': NoteType.from_dict(obj['note_type']) if obj.get('note_type') is not None else None,
                'data': obj.get('data'),
                'time': obj.get('time'),
            }
        )
        return _obj
