# coding: utf-8

"""
Defect Dojo API v2

Defect Dojo - Open Source vulnerability Management made easy. Prefetch related parameters/responses not yet in the schema.

The version of the OpenAPI document: 2.44.1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import date
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt
from typing_extensions import Self

from defectdojo_api_generated.models.paginated_questionnaire_answered_survey_list_prefetch import (
    PaginatedQuestionnaireAnsweredSurveyListPrefetch,
)


class QuestionnaireAnsweredSurvey(BaseModel):
    """
    QuestionnaireAnsweredSurvey
    """  # noqa: E501

    id: StrictInt
    completed: Optional[StrictBool] = None
    answered_on: Optional[date] = None
    engagement: Optional[StrictInt] = None
    survey: StrictInt
    assignee: Optional[StrictInt] = None
    responder: Optional[StrictInt] = None
    prefetch: Optional[PaginatedQuestionnaireAnsweredSurveyListPrefetch] = None
    __properties: ClassVar[List[str]] = [
        'id',
        'completed',
        'answered_on',
        'engagement',
        'survey',
        'assignee',
        'responder',
        'prefetch',
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QuestionnaireAnsweredSurvey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set(
            [
                'id',
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of prefetch
        if self.prefetch:
            _dict['prefetch'] = self.prefetch.to_dict()
        # set to None if answered_on (nullable) is None
        # and model_fields_set contains the field
        if self.answered_on is None and 'answered_on' in self.model_fields_set:
            _dict['answered_on'] = None

        # set to None if engagement (nullable) is None
        # and model_fields_set contains the field
        if self.engagement is None and 'engagement' in self.model_fields_set:
            _dict['engagement'] = None

        # set to None if assignee (nullable) is None
        # and model_fields_set contains the field
        if self.assignee is None and 'assignee' in self.model_fields_set:
            _dict['assignee'] = None

        # set to None if responder (nullable) is None
        # and model_fields_set contains the field
        if self.responder is None and 'responder' in self.model_fields_set:
            _dict['responder'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QuestionnaireAnsweredSurvey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                'id': obj.get('id'),
                'completed': obj.get('completed'),
                'answered_on': obj.get('answered_on'),
                'engagement': obj.get('engagement'),
                'survey': obj.get('survey'),
                'assignee': obj.get('assignee'),
                'responder': obj.get('responder'),
                'prefetch': PaginatedQuestionnaireAnsweredSurveyListPrefetch.from_dict(obj['prefetch'])
                if obj.get('prefetch') is not None
                else None,
            }
        )
        return _obj
