# coding: utf-8

"""
Defect Dojo API v2

Defect Dojo - Open Source vulnerability Management made easy. Prefetch related parameters/responses not yet in the schema.

The version of the OpenAPI document: 2.44.1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict
from typing_extensions import Self

from defectdojo_api_generated.models.status_statistics import StatusStatistics


class SeverityStatusStatistics(BaseModel):
    """
    SeverityStatusStatistics
    """  # noqa: E501

    info: StatusStatistics
    low: StatusStatistics
    medium: StatusStatistics
    high: StatusStatistics
    critical: StatusStatistics
    total: StatusStatistics
    __properties: ClassVar[List[str]] = ['info', 'low', 'medium', 'high', 'critical', 'total']

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SeverityStatusStatistics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of info
        if self.info:
            _dict['info'] = self.info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of low
        if self.low:
            _dict['low'] = self.low.to_dict()
        # override the default output from pydantic by calling `to_dict()` of medium
        if self.medium:
            _dict['medium'] = self.medium.to_dict()
        # override the default output from pydantic by calling `to_dict()` of high
        if self.high:
            _dict['high'] = self.high.to_dict()
        # override the default output from pydantic by calling `to_dict()` of critical
        if self.critical:
            _dict['critical'] = self.critical.to_dict()
        # override the default output from pydantic by calling `to_dict()` of total
        if self.total:
            _dict['total'] = self.total.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SeverityStatusStatistics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                'info': StatusStatistics.from_dict(obj['info']) if obj.get('info') is not None else None,
                'low': StatusStatistics.from_dict(obj['low']) if obj.get('low') is not None else None,
                'medium': StatusStatistics.from_dict(obj['medium']) if obj.get('medium') is not None else None,
                'high': StatusStatistics.from_dict(obj['high']) if obj.get('high') is not None else None,
                'critical': StatusStatistics.from_dict(obj['critical']) if obj.get('critical') is not None else None,
                'total': StatusStatistics.from_dict(obj['total']) if obj.get('total') is not None else None,
            }
        )
        return _obj
